;;;; cl-scopes/test-csys - testing for the scopes-csys system.

(defpackage :scopes/test-csys
  (:use :common-lisp)
  (:local-nicknames (:alx :alexandria)
                    (:actor :scopes/core/actor)
                    (:async :scopes/util/async)
                    (:config :scopes/config)
                    (:core :scopes/core)
                    (:csys :scopes/csys)
                    (:logging :scopes/logging)
                    (:message :scopes/core/message)
                    (:shape :scopes/shape)
                    (:util :scopes/util)
                    (:t :scopes/testing))
  (:export #:run)
  (:import-from :scopes/testing #:deftest #:== #:!=))

(in-package :scopes/test-csys)

;;;; test runner

(defun run ()
  (let* ((t:*test-suite* (make-instance 't:test-suite :name "csys")))
    (load (t:test-path "config-csys" "etc"))
    (unwind-protect
      (progn
        (test-basic))
      (async:finish)
      (t:show-result))))

(deftest test-basic ()
  (csys:setup)
  (!= csys:*dispatcher* nil)
  (actor:send (core:mailbox csys:*dispatcher*) (message:create '(:test)))
  (actor:send (core:mailbox csys:*dispatcher*) (message:create '(:stop)))
  ;(actor:stop (core:mailbox csys:*dispatcher*))
  (csys:start)
  )
